Package org.apache.lucene.index

# Class SortedNumericDocValues

java.lang.Object
org.apache.lucene.search.DocIdSetIterator
org.apache.lucene.index.SortedNumericDocValues

Direct Known Subclasses:
  `FilterSortedNumericDocValues`

public abstract class SortedNumericDocValues extends DocIdSetIterator
A list of per-document numeric values, sorted according to `Long.compare(long, long)`.

## Field Summary

### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

`NO_MORE_DOCS`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`SortedNumericDocValues()`
Sole constructor.

## Method Summary

Modifier and Type
Method
Description
`abstract boolean`
`advanceExact(int target)`
Advance the iterator to exactly `target` and return whether `target` has a value.
`abstract int`
`docValueCount()`
Retrieves the number of values for the current document.
`abstract long`
`nextValue()`
Iterates to the next value in the current document.

### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

`advance, all, cost, docID, empty, nextDoc, range, slowAdvance`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### SortedNumericDocValues

protected SortedNumericDocValues()
Sole constructor. (For invocation by subclass constructors, typically implicit.)

## Method Details

### nextValue

public abstract long nextValue() throws IOException
Iterates to the next value in the current document. Do not call this more than `docValueCount()` times for the document.

Throws:
  `IOException`

### docValueCount

public abstract int docValueCount()
Retrieves the number of values for the current document. This must always be greater than zero. It is illegal to call this method after `advanceExact(int)` returned `false`.

### advanceExact

public abstract boolean advanceExact(int target) throws IOException
Advance the iterator to exactly `target` and return whether `target` has a value. `target` must be greater than or equal to the current `doc ID` and must be a valid doc ID, ie. ≥ 0 and < `maxDoc`. After this method returns, `DocIdSetIterator.docID()` returns `target`.

Throws:
  `IOException`